import { parse } from 'next/dist/compiled/stacktrace-parser';
import { getHydrationErrorStackInfo, isReactHydrationErrorStack } from '../../../is-hydration-error';
const regexNextStatic = /\/_next(\/static\/.+)/;
export function parseStack(stack) {
    const messageAndStack = stack.replace(/^Error: /, '');
    if (isReactHydrationErrorStack(messageAndStack)) {
        const { stack: parsedStack } = getHydrationErrorStackInfo(messageAndStack);
        if (parsedStack) {
            stack = parsedStack;
        }
    }
    const frames = parse(stack);
    return frames.map((frame)=>{
        try {
            const url = new URL(frame.file);
            const res = regexNextStatic.exec(url.pathname);
            if (res) {
                var _process_env___NEXT_DIST_DIR_replace, _process_env___NEXT_DIST_DIR;
                const distDir = (_process_env___NEXT_DIST_DIR = process.env.__NEXT_DIST_DIR) == null ? void 0 : (_process_env___NEXT_DIST_DIR_replace = _process_env___NEXT_DIST_DIR.replace(/\\/g, '/')) == null ? void 0 : _process_env___NEXT_DIST_DIR_replace.replace(/\/$/, '');
                if (distDir) {
                    frame.file = 'file://' + distDir.concat(res.pop()) + url.search;
                }
            }
        } catch (e) {}
        return frame;
    });
}

//# sourceMappingURL=parseStack.js.map