import type { AsyncStorageWrapper } from './async-storage-wrapper';
import type { StaticGenerationStore } from '../../client/components/static-generation-async-storage.external';
import type { IncrementalCache } from '../lib/incremental-cache';
import type { RenderOptsPartial } from '../app-render/types';
import type { FetchMetric } from '../base-http';
import type { RequestLifecycleOpts } from '../base-server';
export type StaticGenerationContext = {
    urlPathname: string;
    requestEndedState?: {
        ended?: boolean;
    };
    renderOpts: {
        incrementalCache?: IncrementalCache;
        isOnDemandRevalidate?: boolean;
        fetchCache?: StaticGenerationStore['fetchCache'];
        isServerAction?: boolean;
        pendingWaitUntil?: Promise<any>;
        experimental: Pick<RenderOptsPartial['experimental'], 'isRoutePPREnabled' | 'after'>;
        /**
         * Fetch metrics attached in patch-fetch.ts
         **/
        fetchMetrics?: FetchMetric[];
    } & Pick<RenderOptsPartial, 'originalPathname' | 'supportsDynamicResponse' | 'isRevalidate' | 'nextExport' | 'isDraftMode' | 'isDebugPPRSkeleton'> & Partial<RequestLifecycleOpts>;
};
export declare const StaticGenerationAsyncStorageWrapper: AsyncStorageWrapper<StaticGenerationStore, StaticGenerationContext>;
